unit DoIt;

interface

uses Graphics, Dialogs, SysUtils, Classes, Controls, Forms, WinProcs,
     FTP4W,
     Progress, Profiles, Files, Code, LongFile;
Procedure DoTransfer (ToDo:TProfile);
procedure DoDisconnect;
procedure DoCancel;

var CanGoByeBye: boolean;
    RunningAuto: boolean;
    DateStart: TDateTime;

implementation

type TFileInformation=class(TObject)
     Name :string[230];
     LongName :string[230];
     DirIndex :Integer;
     Size :Longint;
     DateTime :Extended;
     Year: integer;
     ToCopy, ToDelete :Boolean;
     end;

var
{    LocalDirs :array[0..63] of string[63];}
    LocalDirs: TStringList;
{    LongDirs :array[0..63] of string[127];}
    LongDirs :TStringList;
    CreateDir :array[0..2000] of boolean;
    RemoveDir :array[0..2000] of boolean;
    FirstFileInLocDir :TStringList;
    FirstFileInRemDir :TStringList;
    LastFileInLocDir :TStringList;
    LastFileInRemDir :TStringList;
    NumLocalDirs :integer;
{    LocalFiles :array[0..2048] of TFileInformation;}
    LocalFiles :TList;
    NumLocalFiles :integer;
    TotalLocalSize :longint;
    RemoteDirs :TStringList;
    NumRemoteDirs :integer;
{    RemoteFiles :array[0..2048] of TFileInformation;}
    RemoteFiles :TList;
    NumRemoteFiles :integer;
    TotalRemoteSize :longint;
    ProfileToDo :TProfile;
    FilesToCopy, DirsToCreate, DirsToRemove, FilesToDelete: Integer;
    FilesToCopySize: Longint;
    P21LogFile: integer;
{    FLogText: integer;
    FErrLogText: integer;}
    LogText: TStringList;
    ErrLogText: TStringList;
    LocLogText: TStringList;
    RemLogText: TStringList;
    ActLogText: TStringList;
    Errors: boolean;


procedure AddToLog(toadd:string; save:boolean);
begin
  LogText.Add (toadd);
  FrmProgress.LblLog.Font.Color:=clGreen;
  if save then
    if ProfileToDo.AllLogs then
      LogText.SaveToFile (GetMyPath+'session.log');
end;
procedure AddToErrLog(toadd:string; save:boolean);
begin
  Errors:=true;
  ErrLogText.Add (toadd);
  ErrLogText.SaveToFile (GetMyPath+'errors.log');
  FrmProgress.LblLog.Font.Color:=clMaroon;
  FrmProgress.LblLog.Caption:='WholeSite has encountered at least one problem, '+
                              'all errors/warnings will be saved in the file "errors.log"';
end;
procedure AddToActLog(toadd:string; save:boolean);
begin
  ActLogText.Add (toadd);
  if save then
    if ProfileToDo.AllLogs then
      ActLogText.SaveToFile (GetMyPath+'actions.log');
end;
procedure AddToRemLog(toadd:string; save:boolean);
begin
  RemLogText.Add (toadd);
  if save then
    if ProfileToDo.AllLogs then
      RemLogText.SaveToFile (GetMyPath+'remfiles.lst');
end;
procedure AddToLocLog(toadd:string; save:boolean);
begin
  LocLogText.Add (toadd);
  if save then
    if ProfileToDo.AllLogs then
      LocLogText.SaveToFile (GetMyPath+'locfiles.lst');
end;


procedure DoCancel;
begin
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('**********************',false);
  AddToLog ('User Cancelled Process',false);
  AddToLog ('**********************',true);
  AddToErrLog ('',false);
  AddToErrLog ('',false);
  AddToErrLog ('** User Cancelled Process **',true);
  DoDisconnect;
end;


procedure DoDisconnect;
var a:integer;
begin
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('Disconnect:',false);
  AddToLog ('===========',false);
  AddToLog ('',false);
  AddToLog ('{Done}',true);
  With FrmProgress do begin
    LblD.Font.Color:=clWhite;
    LblD.Refresh;
    CloseFTP;
    for a:=0 to NumLocalFiles-1 do TFileInformation(LocalFiles.Items[a]).Free;
    LocalFiles.Free;
    LocalDirs.Free;
    LongDirs.Free;
    RemoteDirs.Free;
    FirstFileInLocDir.Free;
    FirstFileInRemDir.Free;
    LastFileInLocDir.Free;
    LastFileInRemDir.Free;
    for a:=0 to NumRemoteFiles-1 do TFileInformation(RemoteFiles.Items[a]).Free;
    LblD.Font.Color:=clWindowText;
    LblDProg.Caption:='Done';
    LblD.Refresh;
    LblDProg.Refresh;
  end;
  if ProfileToDo.AllLogs then begin
    LogText.SaveToFile (GetMyPath+'session.log');
    LocLogText.SaveToFile (GetMyPath+'locfiles.lst');
    RemLogText.SaveToFile (GetMyPath+'remfiles.lst');
    ActLogText.SaveToFile (GetMyPath+'actions.log');
  end;
  ErrLogText.SaveToFile (GetMyPath+'errors.log');
  LogText.Free;
  ErrLogText.Free;
  LocLogText.Free;
  RemLogText.Free;
  ActLogText.Free;
{  _lclose(FLogText);
  _lclose(FErrLogText);
  _lclose(P21LogFile);}
  FrmProgress.Button1.Caption:='Close';
end;


function DoDeleteFiles:boolean;
var a, b, numdone, status: integer;
    fs: pchar;
    tempdir: string;
begin
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('Delete Old Files:',false);
  AddToLog ('=================',false);
  AddToLog ('',false);
  AddToLog ('{See Actions.Log for details}',true);
  AddToActLog ('',false);
  AddToActLog ('',false);
  AddToActLog ('',false);
  AddToActLog ('Delete Old Files:',false);
  AddToActLog ('=================',false);
  AddToActLog ('',true);
  Result:=true;
  numdone:=0;
  with FrmProgress do begin
    LblDF.Font.Color:=clWhite;
    LblDFProg.Font.Color:=clWhite;
    If FilesToDelete=0 then LblDFProg.Caption:='None to delete';
    LblDF.Refresh;
    LblDFProg.Refresh;
    for a:=0 to NumRemoteFiles-1 do begin
      if TFileInformation(RemoteFiles.Items[a]).ToDelete then begin
        fs:='1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890'+
            '1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890'+
            '1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890';
        tempdir:=RemoteDirs[TFileInformation(RemoteFiles.Items[a]).DirIndex];
        for b:=1 to length(tempdir) do
          if tempdir[b]='\' then tempdir[b]:='/';
        if ProfileToDo.Upper then tempdir:=UpperCase(tempdir);
        if ProfileToDo.Upper then begin
          TFileInformation(RemoteFiles.Items[a]).Name:=UpperCase(TFileInformation(RemoteFiles.Items[a]).Name);
          TFileInformation(RemoteFiles.Items[a]).LongName:=UpperCase(TFileInformation(RemoteFiles.Items[a]).LongName);
        end;
        if tempdir='' then
          StrPCopy(fs, TFileInformation(RemoteFiles.Items[a]).Name)
        else
          StrPCopy(fs, tempdir+'/'+TFileInformation(RemoteFiles.Items[a]).Name);
        inc(numdone);
        LblDFProg.Caption:=IntToStr(numdone)+':  '+StrPas(fs);
        LblDFProg.Refresh;
{        if pos(' ',StrPas(fs))<>0 then StrPCopy(fs,'"'+StrPas(fs)+'"');}
        status:=FtpDeleteFile(fs);
        if Status<>FTPERR_OK then begin
{          MessageDlg('Error deleting file '+StrPas(fs)+'   Error was '+StrPas(FTP4W_Error(Status)),mtError,[mbOK],0);}
          AddToActLog ('Error deleting file '+StrPas(fs)+', Error was '+StrPas(FTP4W_Error(Status)),true);
          AddToErrLog ('Error ('+StrPas(FTP4W_Error(Status))+') when deleting file '+StrPas(fs),true);
          Result:=false;
        end else AddToActLog (StrPas(fs)+' deleted',true);
        Application.ProcessMessages;
      end;
    end;
    LblDF.Font.Color:=clWindowText;
    LblDFProg.Font.Color:=clWindowText;
    if FilesToDelete<>0 then
      if result=false then begin
        LblDFProg.Caption:='Done, but at least one problem occurred';
        AddToLog('{Done, but at least one problem occurred}',true);
        AddToActLog('{Done, but at least one problem occurred}',true)
      end else begin
        LblDFProg.Caption:='Done';
        AddToActLog('{OK}',true);
        AddToLog('{OK}',true)
      end;
    LblDF.Refresh;
    LblDFProg.Refresh;
  end;
end;


function DoCopyFiles:boolean;
var a, b, numdone, status: integer;
    temprem, templocdisp, temploc, templocdisplong, temploclong: pchar;
    tempfile, tempfilelong: string;
    templocdir: string;
    reg: string;
    stime: TDateTime;
    ptime: TDateTime;
begin
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('Upload Files:',false);
  AddToLog ('=============',false);
  AddToLog ('',false);
  AddToLog ('{See Actions.Log for details}',true);
  AddToActLog ('',false);
  AddToActLog ('',false);
  AddToActLog ('',false);
  AddToActLog ('Upload Files:',false);
  AddToActLog ('=============',false);
  AddToActLog ('',true);
  reg:=CheckRegFile(GetMyPath+'regcode.dat');
  TotalToDo:=FilesToCopySize;
  TotalDone:=0;
  Result:=true;
  with FrmProgress do begin
    LblCF.Font.Color:=clWhite;
    LblCFProg.Font.Color:=clWhite;
    If FilesToCopy=0 then LblCFProg.Caption:='None to copy';
    LblCF.Refresh;
    LblCFProg.Refresh;
    numdone:=0;
    for a:=0 to NumLocalFiles-1 do begin
      if TFileInformation(LocalFiles.Items[a]).ToCopy then begin
        inc(numdone);
        if ProfileToDo.PauseAfter>0 then begin
          if (numdone mod ProfileToDo.PauseAfter)=0 then begin
             LblCFProg.Caption:='Waiting';
             LblCFProg.Refresh;
             ptime:=now;
             while now<(ptime+EncodeTime(0,0,ProfileTodo.PauseFor,0)) do
                Application.ProcessMessages;
             LblCFProg.Caption:='Waiting';
             LblCFProg.Refresh;
          end;
        end;
        temprem:='1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890'+
                 '1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890'+
                 '1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890';
        temploc:='123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012'+
                 '123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012'+
                 '123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012';
        templocdisp:='12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901'+
                     '12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901'+
                     '12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901';
        temploclong:='1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123'+
                 '1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123'+
                 '1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123';
        templocdisplong:=
                 '12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234'+
                 '12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234'+
                 '12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234';
        tempfile:=TFileInformation(LocalFiles.Items[a]).Name;
        if LowerCase(copy(tempfile,Length(tempfile)-4,5))='.html' then
           tempfile:=Copy(tempfile,1,Length(tempfile)-1);
        if LocalDirs[TFileInformation(LocalFiles.Items[a]).DirIndex]='' then
          StrPCopy(templocdisp, ProfileToDo.LocalRoot+
                                '\'+tempfile)
        else
          StrPCopy(templocdisp, ProfileToDo.LocalRoot+
                                '\'+LocalDirs[TFileInformation(LocalFiles.Items[a]).DirIndex]+
                                '\'+tempfile);
        if pos('.htm',LowerCase(StrPas(templocdisp)))>0 then reg:=CheckRegFile(GetMyPath+'regcode.dat');
        if reg='' then begin
          if pos('.htm',LowerCase(StrPas(templocdisp)))>0 then begin
            temploc:='temp.tmp';
            AddRegMessage(StrPas(templocdisp),StrPas(temploc));
          end else begin
            temploc:=templocdisp;
          end;
        end else begin
          temploc:=templocdisp;
        end;
        templocdir:=LongDirs[TFileInformation(LocalFiles.Items[a]).DirIndex];
        for b:=1 to length(templocdir) do
          if templocdir[b]='\' then templocdir[b]:='/';
        if ProfileToDo.Upper then templocdir:=UpperCase(templocdir);
        if ProfileToDo.Upper then begin
          TFileInformation(LocalFiles.Items[a]).Name:=UpperCase(TFileInformation(LocalFiles.Items[a]).Name);
          TFileInformation(LocalFiles.Items[a]).LongName:=UpperCase(TFileInformation(LocalFiles.Items[a]).LongName);
        end;
        if templocdir='' then
          StrPCopy(temprem, './'+TFileInformation(LocalFiles.Items[a]).LongName)
        else
          StrPCopy(temprem, './'+templocdir+'/'+TFileInformation(LocalFiles.Items[a]).LongName);
        prog:=IntToStr(NumDone)+':  '+StrPas(templocdisp)+'    ->    '+StrPas(temprem);
        LblCFProg.Caption:=prog;
        LblCFProg.Refresh;
        StrPCopy(temploclong,GetLongSpec(StrPas(temploc)));
{        AddToLog(StrPas(temploc)+' '+strpas(temprem));}
{        if pos(' ',StrPas(temprem))<>0 then StrPCopy(temprem,'"'+StrPas(temprem)+'"');}
        status:=FtpSendFile(temploc, temprem, TYPE_I, false, 0, 0);
        if Status=FTPERR_UNEXPECTEDANSWER then begin
          prog:=IntToStr(NumDone)+':  Data connection droped while copying to '+StrPas(temprem)+' - Waiting to retry...';
          LblCFProg.Caption:=prog;
          LblCFProg.Refresh;
          stime:=Now;
          while (Now-stime) > EncodeTime(0,0,5,0) do Application.ProcessMessages;
          prog:=IntToStr(NumDone)+':  Data connection dropped while copying ro '+StrPas(temprem)+' - Retrying...';
          LblCFProg.Caption:=prog;
          LblCFProg.Refresh;
          status:=FtpSendFile(temploc, temprem, TYPE_I, false, 0, 0);
          if Status=FTPERR_UNEXPECTEDANSWER then begin
            prog:=IntToStr(NumDone)+':  Data connection dropped while copying to '
                                   +StrPas(temprem)+' - Waiting to retry again...';
            LblCFProg.Caption:=prog;
            LblCFProg.Refresh;
            stime:=Now;
            while (Now-stime) > EncodeTime(0,0,5,0) do Application.ProcessMessages;
            prog:=IntToStr(NumDone)+':  Data connection dropped while copying to '+StrPas(temprem)+' - Retrying again...';
            LblCFProg.Caption:=prog;
            LblCFProg.Refresh;
            status:=FtpSendFile(temploc, temprem, TYPE_I, false, 0, 0);
          end;
        end;
        if Status<>FTPERR_OK then begin
{          MessageDlg('Error copying to file '+StrPas(temprem)+', Error was '+StrPas(FTP4W_Error(Status)),mtError,[mbOK],0);}
          Result:=false;
          AddToActLog ('Error uploading file '+StrPas(templocdisp)+' ['+StrPas(temploc)+']'+' as '+StrPas(temprem)+
                       ', Error was '+StrPas(FTP4W_Error(Status)),true);
          AddToErrLog ('Error ('+StrPas(FTP4W_Error(Status))+') when uploading file '
                          +StrPas(templocdisp)+' as '+StrPas(temprem)
                          +' ['+StrPas(temploc)+']'
                          ,true);
          Result:=false;
        end else AddToActLog (StrPas(templocdisp)+' uploaded as '+StrPas(temprem)+' ['+StrPas(temploc)+']',true);
        inc(TotalDone, TFileInformation(LocalFiles.Items[a]).Size);
        Application.ProcessMessages;
      end;
    end;
    TotalDone:=0;
    LblCF.Caption:='Copy Files';
    LblCF.Font.Color:=clWindowText;
    LblCFProg.Font.Color:=clWindowText;
    if FilesToCopy<>0 then
      if result=false then begin
        LblCFProg.Caption:='Done, but at least one problem occurred';
        AddToLog('{Done, but at least one problem occurred}',true);
        AddToActLog('{Done, but at least one problem occurred}',true)
      end else begin
        LblCFProg.Caption:='Done';
        AddToLog('{OK}',true);
        AddToActLog('{OK}',true)
      end;
    LblCF.Refresh;
    LblCFProg.Refresh;
  end;
end;


function DoMakeDirectories:boolean;
var a, b, numdone, status: integer;
    temp, temp2: pchar;
    tempdir: string;
begin
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('Create Directories:',false);
  AddToLog ('===================',false);
  AddToLog ('',false);
  AddToLog ('{See Actions.Log or details}',true);
  AddToActLog ('',false);
  AddToActLog ('',false);
  AddToActLog ('',false);
  AddToActLog ('Create Directories:',false);
  AddToActLog ('===================',false);
  AddToActLog ('',true);
  Result:=true;
  with FrmProgress do begin
    LblMD.Font.Color:=clWhite;
    LblMDProg.Font.Color:=clWhite;
    If DirsToCreate=0 then begin
      LblMDProg.Caption:='None to create';
      LblMDProg.Font.Style:=[];
    end;
    LblMD.Refresh;
    LblMDProg.Refresh;
    numdone:=0;
    for a:=0 to NumLocalDirs-1 do
      if CreateDir[a] then begin
        inc(numdone);
        LblMDProg.Caption:='Creating directory '+IntToStr(numdone)+' of '+IntToStr(DirsToCreate)+'  ('+LongDirs[a]+')';
        LblMDProg.refresh;
        temp:='12345678901234567890123456789012345678901234567890123456789012345678901234567890'+
              '12345678901234567890123456789012345678901234567890123456789012345678901234567890'+
              '12345678901234567890123456789012345678901234567890123456789012345678901234567890';
        temp2:=temp;
        tempdir:=LongDirs[a];
        for b:=1 to Length(TempDir) do
          if tempdir[b]='\' then tempdir[b]:='/';
        if ProfileToDo.Upper then tempdir:=UpperCase(TempDir);
        StrPCopy(temp, tempdir);
{        if pos(' ',StrPas(temp))<>0 then StrPCopy(temp,'"'+StrPas(temp)+'"');}
        status:=FtpMKD(temp,temp2,80);
        Application.ProcessMessages;
        if status<>FTPERR_OK then begin
{          MessageDlg('Error creating directory '+tempdir+', Error was '+StrPas(FTP4W_Error(Status)),mtError,[mbOK],0);}
          AddToActLog ('Error creating directory '+tempdir+', Error was '+StrPas(FTP4W_Error(Status)),true);
          AddToErrLog ('Error ('+StrPas(FTP4W_Error(Status))+') when creating directory '+tempdir,true);
          Result:=false;
        end else AddToActLog (tempdir+' created',true);
      end;
    LblMD.Font.Color:=clWindowText;
    LblMDProg.Font.Color:=clWindowText;
    if DirsToCreate<>0 then
      if result=false then begin
        LblMDProg.Caption:='Done, but at least one problem occurred';
        AddToLog('{Done, but at least one problem occurred}',true);
        AddToActLog('{Done, but at least one problem occurred}',true);
        AddToErrLog('{Note: Errors in creating directories can cause further errors, when copying files}',true)
      end else begin
        LblMDProg.Caption:='Done';
        AddToLog('{OK}',true);
        AddToActLog('{OK}',true)
      end;
    LblMD.Refresh;
    LblMDProg.Refresh;
  end;
end;


function DoRemoveDirectories:boolean;
var a, b, numdone, status: integer;
    temp, temp2: pchar;
    tempdir: string;
begin
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('Remove Directories:',false);
  AddToLog ('===================',false);
  AddToLog ('',false);
  AddToLog ('{See Actions.Log for details}',true);
  AddToActLog ('',false);
  AddToActLog ('',false);
  AddToActLog ('',false);
  AddToActLog ('Remove Directories:',false);
  AddToActLog ('===================',false);
  AddToActLog ('',true);
  Result:=true;
  with FrmProgress do begin
    LblRD.Font.Color:=clWhite;
    LblRDProg.Font.Color:=clWhite;
    If DirsToRemove=0 then begin
      LblRDProg.Caption:='None to remove';
      LblRDProg.Font.Style:=[];
    end;
    LblRD.Refresh;
    LblRDProg.Refresh;
    numdone:=0;
    for a:=NumRemoteDirs-1 downto 0 do
      if RemoveDir[a] then begin
        inc(numdone);
        LblRDProg.Caption:='Removing directory '+IntToStr(numdone)+' of '+IntToStr(DirsToRemove)+'  ('+RemoteDirs[a]+')';
        LblRDProg.refresh;
        temp:='12345678901234567890123456789012345678901234567890123456789012345678901234567890'+
              '12345678901234567890123456789012345678901234567890123456789012345678901234567890'+
              '12345678901234567890123456789012345678901234567890123456789012345678901234567890';
        temp2:=temp;
        tempdir:=RemoteDirs[a];
        for b:=1 to Length(TempDir) do
          if tempdir[b]='\' then tempdir[b]:='/';
{        if ProfileToDo.Upper then tempdir:=UpperCase(TempDir);}
        StrPCopy(temp, tempdir);
{        if pos(' ',StrPas(temp))<>0 then StrPCopy(temp,'"'+StrPas(temp)+'"');}
        status:=FtpRMD(temp);
        Application.ProcessMessages;
        if status<>FTPERR_OK then begin
{          MessageDlg('Error removing directory '+tempdir+', Error was '+StrPas(FTP4W_Error(Status)),mtError,[mbOK],0);}
          AddToActLog ('Error removing directory '+tempdir+', Error was '+StrPas(FTP4W_Error(Status)),true);
          AddToErrLog ('Error ('+StrPas(FTP4W_Error(Status))+') when removing directory '+tempdir,true);
          Result:=false;
        end else AddToActLog (tempdir+' removed',true);
      end;
    LblRD.Font.Color:=clWindowText;
    LblRDProg.Font.Color:=clWindowText;
    if DirsToRemove<>0 then
      if result=false then begin
        LblRDProg.Caption:='Done, but at least one problem occurred';
        AddToLog('{Done, but at least one problem occurred}',true);
        AddToActLog('{Done, but at least one problem occurred}',true)
      end else begin
        LblRDProg.Caption:='Done';
        AddToLog('{OK}',true);
        AddToActLog('{OK}',true)
      end;
    LblRD.Refresh;
    LblRDProg.Refresh;
  end;
end;


procedure DoDecideActions;
var LocalToRemote: array[0..2000] of integer;
    RemoteToLocal: array[0..2000] of integer;
    a, b: integer;
    res: integer;
    reg: string;
    temp: string;
    lf, lt: integer;
begin
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('Decide Actions',false);
  AddToLog ('==============',false);
  AddToLog ('',false);
  reg:=CheckRegFile(GetMyPath+'regcode.dat');
  if reg='' then AddToLog ('Not registered (no reg code found, or reg code invalid) - will add messages to htm(l) files',true)
    else AddToLog ('Registered (to '+reg+') - will not add messages to htm(l) files',true);
  FilesToCopy:=0;
  DirsToCreate:=0;
  FilesToDelete:=0;
  FilesToCopySize:=0;
  with FrmProgress do begin
    LblDA.Font.Color:=clWhite;
    LblDAProg.Font.Color:=clWhite;
    LblDA.Refresh;
    LblDAProg.Refresh;
    {format local dirs}
    for a:=0 to NumLocalDirs-1 do begin
      temp:=LocalDirs[a];
      Delete(temp, 1, length(ProfileToDo.LocalRoot));
      if temp[1]='\' then Delete(temp, 1, 1);
      if ProfileToDo.Upper then temp:=UpperCase(temp) else temp:=LowerCase(temp);
      LocalDirs[a]:=temp;
      temp:=LongDirs[a];
      Delete(temp, 1, length(ProfileToDo.LongRoot));
      if temp[1]='\' then Delete(temp, 1, 1);
      if not ProfileToDo.UseLongFN then
         if ProfileToDo.Upper then temp:=UpperCase(temp) else temp:=LowerCase(temp);
      LongDirs[a]:=temp;
    end;
    {format remote dirs}
    for a:=0 to NumRemoteDirs-1 do begin
      temp:=RemoteDirs[a];
      if temp[1]='.' then Delete(temp, 1, 1);
      if temp[1]='/' then Delete(temp, 1, 1);
      for b:=1 to length(temp) do
        if temp[b]='/' then temp[b]:='\';
      RemoteDirs[a]:=temp;
    end;
    {clear dir connection records}
    for a:=0 to NumLocalDirs-1 do begin
      for b:=0 to NumRemoteDirs-1 do begin
        LocalToRemote[a]:=-1;
        RemoteToLocal[b]:=-1;
      end;
    end;
    {find remote/local dir aliases}
    for a:=0 to NumLocalDirs-1 do begin
      for b:=0 to NumRemoteDirs-1 do
        if LongDirs[a]=RemoteDirs[b] then begin
          LocalToRemote[a]:=b;
          RemoteToLocal[b]:=a;
{          MessageDlg(LocalDirs[a]+' '+RemoteDirs[b], mtInformation, [mbOK], 0);}
{          MessageDlg(RemoteDirs[LocalToRemote[a]]+' '+RemoteDirs[b], mtInformation, [mbOK], 0);}
        end;
    end;
    {format local filenames}
    for a:=0 to NumLocalFiles-1 do begin
      if ProfileToDo.Upper then
         TFileInformation(LocalFiles[a]).Name:=UpperCase(TFileInformation(LocalFiles[a]).Name)
      else TFileInformation(LocalFiles[a]).Name:=LowerCase(TFileInformation(LocalFiles[a]).Name);
      if (not ProfileToDo.UseLongFN) then
         TFileInformation(LocalFiles[a]).LongName:=TFileInformation(LocalFiles[a]).Name;
    end;
    {scan for dirs to create}
    for a:=0 to NumLocalDirs-1 do begin
      if LocalToRemote[a]=-1 then begin
        CreateDir[a]:=true;
        inc(DirsToCreate);
      end;
    end;
    {scan for dirs to delete}
    if ProfileToDo.Delete then begin
      for a:=0 to NumRemoteDirs-1 do begin
        if RemoteToLocal[a]=-1 then begin
          RemoveDir[a]:=true;
          inc(DirsToRemove);
        end;
      end;
    end;
    {To do:  Create 88 directories, copy 8888 files (8888Kb) and delete 8888 files}
    LblDAProg.Caption:='To do:  Create '+IntToStr(DirsToCreate)+' directories, '+
                       'and remove '+IntToStr(DirsToRemove)+'...';
    LblDAProg.Refresh;
    Application.ProcessMessages;
    {scan for files to copy}
    for a:=0 to NumLocalFiles-1 do begin
      if (a mod 20)=0 then Application.ProcessMessages;
      TFileInformation(LocalFiles.Items[a]).ToCopy:=true;      { Default = copy }
      if not ProfileToDo.AllFiles then begin                   { maybe not need to copy [if told to check] }
        if LocalToRemote[TFileInformation(LocalFiles.Items[a]).DirIndex]<>-1 then begin
{          for b:=StrToInt(FirstFileInRemDir[LocalToRemote[TFileInformation(LocalFiles.Items[a]).DirIndex]])
              to StrToInt(LastFileInRemDir[LocalToRemote[TFileInformation(LocalFiles.Items[a]).DirIndex]]) do begin}
          lf:=StrToInt(FirstFileInRemDir[LocalToRemote[TFileInformation(LocalFiles.Items[a]).DirIndex]]);
          lt:=StrToInt(LastFileInRemDir[LocalToRemote[TFileInformation(LocalFiles.Items[a]).DirIndex]]);
          for b:=lf to lt do begin
            if (b mod 40)=0 then Application.ProcessMessages;
            if LocalToRemote[TFileInformation(LocalFiles.Items[a]).DirIndex]=
                         TFileInformation(RemoteFiles.Items[b]).DirIndex then begin
              if TFileInformation(LocalFiles.Items[a]).LongName=
                      TFileInformation(RemoteFiles.Items[b]).LongName then begin
                if TFileInformation(LocalFiles.Items[a]).Size=TFileInformation(RemoteFiles.Items[b]).Size then begin
{              AddToLog('Checking dates: loc='+FloatToStr(TFileInformation(LocalFiles.Items[a]).DateTime)+
                       '  rem='+FloatToStr(TFileInformation(RemoteFiles.Items[b]).DateTime), True);}
                  if TFileInformation(LocalFiles.Items[a]).DateTime<TFileInformation(RemoteFiles.Items[b]).DateTime then begin
{              AddToLog('loc older', True);}
                    TFileInformation(LocalFiles.Items[a]).ToCopy:=false;
                  end;
                end;
                if reg='' then begin
                  if pos('.htm',LowerCase(TFileInformation(LocalFiles.Items[a]).LongName))>0 then begin
                    if TFileInformation(LocalFiles.Items[a]).Size+480=TFileInformation(RemoteFiles.Items[b]).Size then begin
                      if TFileInformation(LocalFiles.Items[a]).DateTime<
                         TFileInformation(RemoteFiles.Items[b]).DateTime then begin
                        TFileInformation(LocalFiles.Items[a]).ToCopy:=false;
                      end;
                    end;
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
      if TFileInformation(LocalFiles.Items[a]).ToCopy=true then begin
        inc(FilesToCopy);
        inc(FilesToCopySize,TFileInformation(LocalFiles.Items[a]).Size);
      end;
    end;
    LblDAProg.Caption:='To do:  Create '+IntToStr(DirsToCreate)+' directories, '
                      +'copy '+IntToStr(FilesToCopy)+' files ('+IntToStr(round(FilesToCopySize/1024))+'KB), '
                      +'and delete '+IntToStr(DirsToRemove)+' dirs...';
    LblDAProg.Refresh;
    Application.ProcessMessages;
    {scan for files to delete}
    if ProfileToDo.Delete then begin
      for a:=0 to NumRemoteFiles-1 do begin
        if (a mod 20)=0 then Application.ProcessMessages;
        TFileInformation(RemoteFiles.Items[a]).ToDelete:=true;
        if RemoteToLocal[TFileInformation(RemoteFiles.Items[a]).DirIndex]>-1 then begin
          if TFileInformation(RemoteFiles.Items[a]).ToCopy then begin
            TFileInformation(RemoteFiles.Items[a]).ToDelete:=false;
          end else begin
            for b:=StrToInt(FirstFileInLocDir[RemoteToLocal[TFileInformation(RemoteFiles.Items[a]).DirIndex]])
                to StrToInt(LastFileInLocDir[RemoteToLocal[TFileInformation(RemoteFiles.Items[a]).DirIndex]]) do begin
{          lf:=StrToInt(FirstFileInLocDir[RemoteToLocal[TFileInformation(RemoteFiles.Items[a]).DirIndex]]);
          lt:=StrToInt(LastFileInLocDir[RemoteToLocal[TFileInformation(RemoteFiles.Items[a]).DirIndex]]);
          for b:=lf to lt do begin}
            if (b mod 40)=0 then Application.ProcessMessages;
              if TFileInformation(RemoteFiles.Items[a]).DirIndex=LocalToRemote[TFileInformation(LocalFiles.Items[b]).DirIndex]
              then begin
                if TFileInformation(RemoteFiles.Items[a]).LongName=
                   TFileInformation(LocalFiles.Items[b]).LongName
                then begin
                  TFileInformation(RemoteFiles.Items[a]).ToDelete:=false;
                end;
              end;
            end;
          end;
        end;
        if (not ProfileToDo.DelFromRoot) and (TFileInformation(RemoteFiles.Items[a]).DirIndex=0)
           then TFileInformation(RemoteFiles.Items[a]).ToDelete:=false;
        if TFileInformation(RemoteFiles.Items[a]).ToDelete=true then begin
          inc(FilesToDelete);
        end;
      end;
    end;
    LblDAProg.Caption:='To do:  Create '+IntToStr(DirsToCreate)+' directories, '
                              +'copy '+IntToStr(FilesToCopy)+' files ('+IntToStr(round(FilesToCopySize/1024))+'KB), '
                              +'delete '+IntToStr(FilesToDelete)+' files '
                              +'and delete '+IntToStr(DirsToRemove)+' dirs';
    LblDAProg.Refresh;
    Application.ProcessMessages;
    {Update Logs}
    AddToLog ('Create '+IntToStr(DirsToCreate)+' directories',true);
    AddToLog ('Copy '+IntToStr(FilesToCopy)+' files ('+IntToStr(round(FilesToCopySize/1024))+'KB)',true);
    AddToLog ('Delete '+IntToStr(FilesToDelete)+' files',true);
    AddToLog ('Delete '+IntToStr(DirsToRemove)+' dirs',true);
    LblDA.Font.Color:=clWindowText;
    LblDAProg.Font.Color:=clWindowText;
    LblDA.Refresh;
    LblDAProg.Refresh;
  end;
end;


{function AddQuotes(i: string):string;
var o, t: string;
    p: integer;
    s: boolean;
begin
    o:=''; t:=''; s:=false;
    for p:=1 to length(i) do begin
        if (i[p]='\') or (i[p]='/') then begin
           if s then begin
              o:=o+'"'+t+'"'+i[p];
           end else begin
              o:=o+t+i[p];
           end;
           s:=false;
           t:='';
        end else begin
           if i[p]=' ' then s:=true;
           t:=t+i[p];
        end;
    end;
    if t<>'' then begin
       if s then begin
          o:=o+'"'+t+'"';
       end else begin
          o:=o+t;
       end;
    end;
    result:=o;
end;}

function AddRemoteDir(DirToDo:integer):Boolean;
var status, a, b: integer;
    part: TStringList;
    pos, pos2: integer;
    temp: string;
    tempnull, tempn2, tdir: pchar;
    LS: TStringList;
    Month, Day, hour, Min: integer;
    ThisMonth, ThisDay, ThisYear: Word;
    LongYear :LongInt;
    sb: boolean;
    tempfs: pchar;
    Dir, dirp: string;
    dirpn: pchar;
    tempprog: string;
    ta: integer;
    tempdirfile: string;
    tempdirfilep: pchar;
begin
  DecodeDate(Now, ThisYear, ThisMonth, ThisDay);
  part:=TstringList.Create;
  for a:=0 to 15 do Part.Add('');
  Dir:=RemoteDirs[DirToDo];
  AddToRemLog ('Scanning directory: '+Dir,true);
  tempdirfilep:='0123456789012345678901234567890123456789012345678901234567890123456789'+
                '0123456789012345678901234567890123456789012345678901234567890123456789'+
                '0123456789012345678901234567890123456789012345678901234567890123456789b';
{  ChDir (GetMyPath);}
  tempdirfile:=GetMyPath+'ftpdir.tmp';
  strPCopy(tempdirfilep,tempdirfile);
  tempnull:='0123456789012345678901234567890123456789012345678901234567890123456789'+
            '0123456789012345678901234567890123456789012345678901234567890123456789'+
            '0123456789012345678901234567890123456789012345678901234567890123456789';
  if system.pos(' ',dir)>0 then begin
     tdir:='0123456789012345678901234567890123456789012345678901234567890123456789'+
           '0123456789012345678901234567890123456789012345678901234567890123456789'+
           '0123456789012345678901234567890123456789012345678901234567890123456789a';
     status:=FtpPWD(tdir, 200);
     Dir:=Dir+'/';
     dirp:='';
     for a:=1 to length(Dir) do begin
         if dir[a]='/' then begin
            dirpn:='0123456789012345678901234567890123456789012345678901234567890123456789a';
            StrPCopy(dirpn,dir);
            FtpCWD(dirpn);
            dirp:='';
         end else begin
            dirp:=dirp+dir[a];
         end;
     end;
     status:=FtpDir(#0, tempdirfilep, true, 0, 0);
     Application.ProcessMessages;
     status:=FtpCWD(tdir);
  end else begin
     StrPCopy(tempnull, Dir);
     status:=FtpDir(tempnull, tempdirfilep, true, 0, 0);
     Application.ProcessMessages;
  end;
  if status<>FTPERR_OK then begin
     Result:=false;
     FrmProgress.LblSRFProg.Caption:=StrPas(FTP4W_Error(Status));
  end
  else begin
    result:=true;
    LS:=TStringList.Create;
    LS.LoadFromFile(tempdirfile);
    if LS.Count>1 then begin
    try
      if Length(LS.Strings[0])>15 then ta:=0 else ta:=1;
      for a:=ta to LS.Count-1 do begin
        pos:=0;
        pos2:=0;
{        part[0]:='';}
        for b:=0 to 15 do part[b]:='';
        temp:=LS.Strings[a];
        for b:=1 to Length(temp) do begin
{          MessageDlg(temp[b],mtInformation,[mbOK],0);}
          if temp[b]=' ' then begin
            if pos2>0 then begin
              pos2:=0;
              inc(pos);
{              part[pos]:='';}
            end;
          end
          else begin
            part[pos]:=part[pos]+temp[b];
            inc(pos2);
          end;
        end;
        LongYear:=-1;
        if (length(part[7])=4) and (length(part[6])<3) then begin
           if (part[7][1]='1') or (part[7][1]='2') then begin
              longyear:=StrToInt(part[7]);
              if (longyear-ThisYear)>1000 then longyear:=longyear-1900;
              part[7]:='00:00';
           end;
        end;
        if (length(part[6])=4) and (length(part[5])<3) then begin
           if (part[6][1]='1') or (part[6][1]='2') then begin
              longyear:=StrToInt(part[6]);
              if (longyear-ThisYear)>1000 then longyear:=longyear-1900;
              part[6]:='00:00';
           end;
        end;
        if (part[7][3]=':') or (part[6][3]=':') then
        begin
          if part[6][3]=':' then begin
            part[15]:=part[14];
            part[14]:=part[13];
            part[13]:=part[12];
            part[12]:=part[11];
            part[11]:=part[10];
            part[10]:=part[9];
            part[9]:=part[8];
            part[8]:=part[7];
            part[7]:=part[6];
            part[6]:=part[5];
            part[5]:=part[4];
            part[4]:=part[3];
          end;
{          MessageDlg(part[0]+'0 '+part[1]+'1 '+part[2]+'2 '+part[3]+'3 '+part[4]+
          '4 '+part[5]+'5 '+part[6]+'6 '+part[7]+'7 '+part[8]+'8     '+IntToStr(NumRemoteFiles),mtInformation,[mbOK],0);}
          if part[8]='' then raise EConvertError.Create('Conversion Error');
{          if system.pos(' ',part[8])>0 then part[8]:='"'+part[8]+'"';}
          if (part[0][1]<>'d') and (part[0][1]<>'D') then begin
{            TFileInformation(RemoteFiles.Items[NumRemoteFiles]:=TFileInformation.Create;}
            RemoteFiles.Add(TFileInformation.Create);
            TFileInformation(RemoteFiles.Items[NumRemoteFiles]).Name:=part[8];
            for b:=9 to 15 do
                if part[b]<>'' then
                   TFileInformation(RemoteFiles.Items[NumRemoteFiles]).Name:=
                   TFileInformation(RemoteFiles.Items[NumRemoteFiles]).Name+
                   ' '+part[b];
{            TFileInformation(RemoteFiles.Items[NumRemoteFiles]).LongName:=part[8];}
{            if system.pos(' ',TFileInformation(RemoteFiles.Items[NumRemoteFiles]).Name)>0 then
               TFileInformation(RemoteFiles.Items[NumRemoteFiles]).Name:=
               '"'+TFileInformation(RemoteFiles.Items[NumRemoteFiles]).Name+'"';}
            TFileInformation(RemoteFiles.Items[NumRemoteFiles]).LongName:=
                   TFileInformation(RemoteFiles.Items[NumRemoteFiles]).Name;
            TFileInformation(RemoteFiles.Items[NumRemoteFiles]).DirIndex:=DirToDo;
            TFileInformation(RemoteFiles.Items[NumRemoteFiles]).Size:=StrToInt(part[4]);
            TotalRemoteSize:=TotalRemoteSize+StrToInt(part[4]);
            Month:=0;
            if part[5]='Jan' then  Month:=1;
            if part[5]='Feb' then  Month:=2;
            if part[5]='Mar' then  Month:=3;
            if part[5]='Apr' then  Month:=4;
            if part[5]='May' then  Month:=5;
            if part[5]='Jun' then  Month:=6;
            if part[5]='Jul' then  Month:=7;
            if part[5]='Aug' then  Month:=8;
            if part[5]='Sep' then  Month:=9;
            if part[5]='Oct' then  Month:=10;
            if part[5]='Nov' then  Month:=11;
            if part[5]='Dec' then  Month:=12;
            Day:=StrToInt(part[6]);
            Hour:=StrToInt(Copy(part[7],1,2));
            Min:=StrToInt(Copy(part[7],4,2));
            TFileInformation(RemoteFiles.Items[NumRemoteFiles]).DateTime:=Month*32+Day
                                                 +(Hour*60+Min)/1440;
            TempProg:='('+IntToStr(LongYear)+')';
            if LongYear=-1 then begin
               if (ThisMonth*32+ThisDay)<(Month*32+Day) then begin
                 LongYear:=ThisYear-1;
                 TempProg:='(probably not this year)';
               end else begin
                 LongYear:=ThisYear;
                 TempProg:='(probably this year)';
               end;
            end;
            TFileInformation(RemoteFiles.Items[NumRemoteFiles]).Year:=LongYear;
            TFileInformation(RemoteFiles.Items[NumRemoteFiles]).DateTime:=
               TFileInformation(RemoteFiles.Items[NumRemoteFiles]).DateTime+LongYear*500;
            AddToRemLog ('Found file: '+TFileInformation(RemoteFiles.Items[NumRemoteFiles]).Name+
                         '   ['+IntToStr(TFileInformation(RemoteFiles.Items[NumRemoteFiles]).Size)+' bytes long'+
                         ', timestamp='+IntToStr(Hour)+':'+IntToStr(Min)+
                         ' on '+IntToStr(Day)+'/'+IntToStr(Month)+' '+TempProg+
                         ']',false);
            inc(NumRemoteFiles);
{            If NumRemoteFiles=2048 then NumRemoteFiles:=2047;}
            If NumRemoteFiles=16300 then begin
               AddToErrLog
               ('Warning - There are more then 16300 files in you site - WholeSite may not function correctly',true);
               AddToLog
               ('Warning - There are more then 16300 files in you site - WholeSite may not function correctly',true);
               AddToRemLog
               ('Warning - There are more then 16300 files in you site - WholeSite may not function correctly',true);
            end;
            If NumRemoteFiles=16302 then NumRemoteFiles:=16301;
            if (NumRemoteFiles mod 20)=0 then Application.ProcessMessages;
            FrmProgress.LblSRFProg.Caption:=
                IntToStr(NumRemoteFiles)
                     + ' files ('
                     + IntToStr(Round(TotalRemoteSize/1024))
                     + 'Kb) found in '
                     + IntToStr(DirToDo+1)
                     + ' directories (inc root) so far';
            FrmProgress.LblSRFProg.Refresh;
          end else {i.e. entry is a dir} begin
            if ProfileToDo.SubDirs then begin
              if (part[8][3]=':') then begin
                 part[8]:=part[9];
                 part[9]:=part[10];
                 part[10]:=part[11];
                 part[11]:=part[12];
                 part[12]:=part[13];
                 part[13]:=part[14];
                 part[14]:=part[15];
                 part[15]:='';
              end;
              if (part[8]<>'.') and (part[8]<>'..') then begin
{                sb:=AddRemoteDir(Dir+'/'+part[8]);
                if sb=false then Result:=false;
                AddToLog ('Scanning directory:'+Dir);}
                for b:=9 to 15 do if part[b]<>'' then part[8]:=part[8]+' '+part[b];
                RemoteDirs[NumRemoteDirs]:=Dir+'/'+part[8];
                CreateDir[NumRemoteDirs]:=true;
                inc(NumRemoteDirs);
                If NumRemoteDirs=2001 then NumRemoteDirs:=2000;
              end;
            end;
          end;
        end;
      end;
    except
      on e: EConvertError do begin
        FrmProgress.LblSRFProg.Caption:='Problem reading directory listing:  '+
                                        'contact WholeSite@bigfoot.com '+
                                        'for more information';
        AddToRemLog ('{Error: A problem occurred reading remote directory listing "'+Dir+'"}',true);
        AddToErrLog ('Error: A problem occurred reading remote directory listing "'+Dir+'"',true);
        Result:=false;
      end;
    end;
    end;
    LS.Free;
  end;
  Part.free;
end;


function DoScanRemoteFiles:Boolean;
var a: integer;
    changed: boolean;
begin
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('Scan Remote Files:',false);
  AddToLog ('==================',false);
  AddToLog ('',false);
  AddToLog ('{See Remfiles.Lst for details}',true);
  Result:=true;
  RemoteDirs:=TStringList.Create;
  FirstFileInRemDir:=TStringList.Create;
  LastFileInRemDir:=TStringList.Create;
  For a:=0 to 2000 do begin RemoteDirs.Add(''); FirstFileInRemDir.Add('0'); LastFileInRemDir.Add('0'); end;
  RemoteFiles:=TList.Create;
  NumRemoteFiles:=0;
  RemoteDirs[0]:='.';
  CreateDir[0]:=true;
  NumRemoteDirs:=1;
  with FrmProgress do
  begin
    LblSRF.Font.Color:=clWhite;
    LblSRFProg.Font.Color:=clWhite;
    LblSRF.Refresh;
    LblSRFProg.Refresh;
{    if AddRemoteDir('.')=false then Result:=false}
    result:=true;
    repeat begin
      changed:=false;
      for a:=0 to NumRemoteDirs-1 do begin
        if CreateDir[a] and result then begin
          FirstFileInRemDir[a]:=IntToStr(NumRemoteFiles);
          if AddRemoteDir(a)=false then result:=false;
   {       AddToLog(IntToStr(a)+' - '+RemoteDirs[a]);}
          CreateDir[a]:=false;
          changed:=true;
          LastFileInRemDir[a]:=IntToStr(NumRemoteFiles-1);
        end;
      end;
    end until changed=false;
    if result then begin
      LblSRFProg.Caption:=IntToStr(NumRemoteFiles)
                         +' files ('
                         +IntToStr(Round(TotalRemoteSize/1024))
                         +'Kb) found in '
                         +IntToStr(NumRemoteDirs)
                         +' directories (inc root)';
      FrmProgress.LblSRFProg.Refresh;
      AddToRemLog ('{'+LblSRFProg.Caption+'}',true);
      AddToLog ('{'+LblSRFProg.Caption+'}',true);
    end;
    LblSRF.Font.Color:=clWindowText;
    LblSRFProg.Font.Color:=clWindowText;
    LblSRF.Refresh;
    LblSRFProg.Refresh;
  end;
end;


function DoLogin:Boolean;
var temp: PChar;
    status: integer;
begin
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('Login:',false);
  AddToLog ('======',false);
  AddToLog ('',false);
  AddToLog ('Send username and password',true);
  Result:=true;
  FrmProgress.LblL.Font.Color:=clWhite;
  FrmProgress.LblLProg.Font.Color:=clWhite;
  FrmProgress.LblL.Refresh;
  FrmProgress.LblLProg.Refresh;
  temp:='01234567890123456789';
  StrPCopy (temp, ProfileToDo.User);
  FrmProgress.LblLProg.Caption:='Sending user ID and password';
  Status := FTPSendUserName (temp);
  Application.ProcessMessages;
  If (Status <> FTPERR_OK) And (Status <> FTPERR_ENTERPASSWORD) Then begin
    FrmProgress.LblLProg.Caption:=StrPas(FTP4W_Error(Status));
    Result:=false;
    AddToLog ('{Error: '+StrPas(FTP4W_Error(Status))+'}',false);
  end else begin
    temp:='01234567890123456789';
    StrPCopy (temp, ProfileToDo.Pass);
{    FrmProgress.LblLProg.Caption:='Sending password';}
    Status := FTPSendPasswd (temp);
    Application.ProcessMessages;
    If (Status <> FTPERR_OK) Then begin
      FrmProgress.LblLProg.Caption:=StrPas(FTP4W_Error(Status));
      Result:=false;
      AddToLog ('{Error: '+StrPas(FTP4W_Error(Status))+'}',false);
      AddToErrLog ('Error loging-on'+
                      ', Error was '+StrPas(FTP4W_Error(Status)),false);
    end else begin
      AddToLog ('{OK}',false);
      if ProfileToDo.RemoteRoot<>'' then begin
        while ProfileToDo.RemoteRoot[1]=' '
              do Delete(ProfileToDo.RemoteRoot,1,1);
        while ProfileToDo.RemoteRoot[Length(ProfileToDo.RemoteRoot)]=' '
              do Delete(ProfileToDo.RemoteRoot,Length(ProfileToDo.RemoteRoot),1);
      end;
      if ProfileToDo.RemoteRoot<>'' then begin
        AddToLog ('Moving to home directory ['+ProfileToDo.RemoteRoot+']',false);
        temp:='01234567890123456789012345678901234567890123456789012345678901234567890123456789'+
              '01234567890123456789012345678901234567890123456789012345678901234567890123456789'+
              '01234567890123456789012345678901234567890123456789012345678901234567890123456789';
        StrPCopy (temp, ProfileToDo.RemoteRoot);
        FrmProgress.LblLProg.Caption:='Moving to home directory';
        if pos(' ',StrPas(temp))<>0 then StrPCopy(temp,'"'+StrPas(temp)+'"');
        Status := FTPCWD (temp);
        Application.ProcessMessages;
        If (Status <> FTPERR_OK) Then begin
          FrmProgress.LblLProg.Caption:=StrPas(FTP4W_Error(Status));
          Result:=false;
          AddToLog ('{Error: '+StrPas(FTP4W_Error(Status))+'}',true);
          AddToErrLog ('Error Changing to directory '+ProfileToDo.RemoteRoot+
                          ', Error was '+StrPas(FTP4W_Error(Status)),true)
        end else AddToLog ('{OK}',true);
      end;
    end;
  end;
  FrmProgress.LblL.Font.Color:=clWindowText;
  FrmProgress.LblLProg.Font.Color:=clWindowText;
  FrmProgress.LblLProg.Caption:='Done';
  FrmProgress.LblL.Refresh;
  FrmProgress.LblLProg.Refresh;
end;


function DoConnect:Boolean;
var temp: PChar;
    status: integer;
    logfn: string;
    plogfn: pchar;
begin
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('',false);
  AddToLog ('Connect',false);
  AddToLog ('=======',false);
  AddToLog ('',false);
  AddToLog ('Host = '+ProFileToDo.Host,true);
  FrmProgress.LblC.Font.Color:=clWhite;
  FrmProgress.LblCProg.Font.Color:=clWhite;
  FrmProgress.LblCProg.Caption:='Contacting host '+ProfileToDo.Host;
  FrmProgress.LblC.Refresh;
  FrmProgress.LblCProg.Refresh;
  Temp:='0123456789012345678901234567890123456789'+
        '0123456789012345678901234567890123456789';
  StrPCopy(temp,ProfileToDo.Host);
  InitFTP;
  Status := FTPInit (FrmProgress.Handle);
  FTPSetSynchronousMode;
  Status:=FTPOpenConnection(temp);
  LogFn:=GetMyPath+'ftpp21.log'+#0;
  pLogFn:=@LogFn[1];
  P21LogFile:=_lcreat(pLogFn,0);
  FTPLogTo(P21LogFile);
  Application.ProcessMessages;
  If (Status = FTPERR_OK) Then
    begin
    FrmProgress.LblCProg.Caption:='Connected';
    AddToLog ('{Connected}',true);
    Result:=True
    end
  else
    begin
    FrmProgress.LblCProg.Caption:=StrPas(FTP4W_Error(Status));
    AddToLog ('{Error: '+StrPas(FTP4W_Error(Status))+'}',true);
    AddToErrLog ('Error connecting to '+ProfileToDo.Host+
                    ', Error was '+StrPas(FTP4W_Error(Status)),true);
    Result:=false;
    end;
  FrmProgress.LblC.Font.Color:=clWindowText;
  FrmProgress.LblCProg.Font.Color:=clWindowText;
  FrmProgress.LblC.Refresh;
  FrmProgress.LblCProg.Refresh;
end;


Procedure AddLocalDir(DirToDo:integer);
var a, cdir :integer;
    tfn :string[139];
    fdata :TSearchRec;
    tWord :Word;
    Year, Month, Day, Hour, Min, Sec, MSec :Word;
    ThisYear : word;
    LongYear: LongInt;
    Dir :string;
    tempprog: string;
begin
  Dir:=LocalDirs[DirToDo];
  with FrmProgress do
  begin
{    if DirToDo>163 then MessageDlg(Dir,mtInformation,[mbOK],0);}
    try
      chdir(Dir);
    except
      on EInOutError do begin
        AddToErrLog('Error: unable to access directory "'+Dir+'" - skipped',true)
      end;
    end;
    DirList.Directory:=Dir;
    if ProfileToDo.UseLongFN then LongDirs[DirToDo]:=GetLongSpec(Dir)
    else LongDirs[DirToDo]:=Dir;
    chdir(Dir);
    AddToLocLog ('Scanning directory '+LongDirs[DirToDo]+' ('+dir+')',true);
    for a:=0 to FileList.Items.Count-1 do
    begin
{      TFileInformation(LocalFiles.Items[NumLocalFiles]:=TFileInformation.Create;}
      LocalFiles.Add(TFileInformation.Create);
      TFileInformation(LocalFiles.Items[NumLocalFiles]).Name:=FileList.Items[a];
      if ProfileToDo.UseLongFN then
         TFileInformation(LocalFiles.Items[NumLocalFiles]).LongName:=GetLongName(FileList.Items[a])
      else TFileInformation(LocalFiles.Items[NumLocalFiles]).LongName:=FileList.Items[a];
      if Copy(Dir,Length(Dir),1)='\' then
        tfn:=Dir+FileList.Items[a]
      else
        tfn:=Dir+'\'+FileList.Items[a];
      FindFirst(tfn, faAnyFile, fdata);
{      DecodeDate(Now, ThisYear, Month, Day);}
      if FileDateToDateTime(fData.Time)>DateStart then
      begin
        AddToLocLog('Warning - file '+FileList.Items[a]
                   +' has a time-stamp later than now, WholeSite may not function correctly',true);
        AddToLog('Warning - file '+FileList.Items[a]
                +' has a time-stamp later than now, WholeSite may not function correctly',true);
        AddToErrLog('Warning - file '+FileList.Items[a]
                   +' has a time-stamp later than now, WholeSite may not function correctly',true);
      end;
      DecodeDate(FileDateToDateTime(fData.Time), Year, Month, Day);
      DecodeTime(FileDateToDateTime(fData.Time), Hour, Min, Sec, MSec);
      TFileInformation(LocalFiles.Items[NumLocalFiles]).DateTime:=( Month*32+Day )+
                                ( (Hour*60+Min+1+ProfileToDo.TimeDif)/1440 );
{      if ThisYear>Year then
         TFileInformation(LocalFiles.Items[NumLocalFiles]).DateTime:=
         TFileInformation(LocalFiles.Items[NumLocalFiles]).DateTime-32*13;}
      TFileInformation(LocalFiles.Items[NumLocalFiles]).Year:=Year;
      LongYear:=Year;
      TFileInformation(LocalFiles.Items[NumLocalFiles]).DateTime:=
         TFileInformation(LocalFiles.Items[NumLocalFiles]).DateTime+LongYear*500;
      TFileInformation(LocalFiles.Items[NumLocalFiles]).size:=fData.Size;
      TotalLocalSize:=TotalLocalSize+fData.Size;
      TFileInformation(LocalFiles.Items[NumLocalFiles]).DirIndex:=DirToDo;
      if ProfileToDo.Rename then begin
        if copy(TFileInformation(LocalFiles.Items[NumLocalFiles]).Name,
                Length(TFileInformation(LocalFiles.Items[NumLocalFiles]).Name)-3,
                4)='.htm' then
                          TFileInformation(LocalFiles.Items[NumLocalFiles]).Name
                          :=TFileInformation(LocalFiles.Items[NumLocalFiles]).Name+'l';
        if copy(TFileInformation(LocalFiles.Items[NumLocalFiles]).Name,
                Length(TFileInformation(LocalFiles.Items[NumLocalFiles]).Name)-3,
                4)='.HTM' then
                          TFileInformation(LocalFiles.Items[NumLocalFiles]).Name
                          :=TFileInformation(LocalFiles.Items[NumLocalFiles]).Name+'L';
        if copy(TFileInformation(LocalFiles.Items[NumLocalFiles]).LongName,
                Length(TFileInformation(LocalFiles.Items[NumLocalFiles]).LongName)-3,
                4)='.htm' then
                          TFileInformation(LocalFiles.Items[NumLocalFiles]).LongName
                          :=TFileInformation(LocalFiles.Items[NumLocalFiles]).LongName+'l';
        if copy(TFileInformation(LocalFiles.Items[NumLocalFiles]).LongName,
                Length(TFileInformation(LocalFiles.Items[NumLocalFiles]).LongName)-3,
                4)='.HTM' then
                          TFileInformation(LocalFiles.Items[NumLocalFiles]).LongName
                          :=TFileInformation(LocalFiles.Items[NumLocalFiles]).LongName+'L';
      end;
      TempProg:='Found file: '+TFileInformation(LocalFiles.Items[NumLocalFiles]).LongName+
                ' ('+LowerCase(FileList.Items[a])+')';
      AddToLocLog(TempProg+
                  '   ['+IntToStr(fData.Size)+' bytes,'+
                  ' timestamp='+IntToStr(Hour)+':'+IntToStr(Min)+
                  ' on '+IntToStr(Day)+'/'+IntToStr(Month)+'/'+IntToStr(LongYear)+
                  ']',false);
      if system.pos(' ',TFileInformation(LocalFiles.Items[NumLocalFiles]).Name)>0 then
         TFileInformation(LocalFiles.Items[NumLocalFiles]).Name:=
         '"'+TFileInformation(LocalFiles.Items[NumLocalFiles]).Name+'"';
      Inc(NumLocalFiles);
{      If NumLocalFiles=2048 then NumLocalFiles:=2047;}
      If NumLocalFiles=16300 then begin
         AddToLocLog('Warning - There are more then 16300 files in you site - WholeSite may not function correctly',true);
         AddToLog('Warning - There are more then 16300 files in you site - WholeSite may not function correctly',true);
         AddToErrLog('Warning - There are more then 16300 files in you site - WholeSite may not function correctly',true);
      end;
      If NumLocalFiles=16302 then NumLocalFiles:=16301;
      if (NumLocalFiles mod 20)=0 then Application.ProcessMessages;
    end;
    LblSLFProg.Caption:=
             IntToStr(NumLocalFiles)
           + ' files ('
           + IntToStr(Round(TotalLocalSize/1024))
           + 'Kb) found in '
           + IntToStr(DirToDo+1)
           + ' directories (inc root)';
    LblSLFProg.Refresh;

    if ProfileToDo.SubDirs then begin
      cdir:=-1;
      for a:=0 to DirList.Items.Count-1 do
      begin
        if LowerCase(DirList.GetItemPath(a)) = LowerCase(dir) then
          cdir:=a;
      end;
      if cdir>-1 then
        if cdir<DirList.Items.Count-1 then
          for a:=cdir+1 to DirList.Items.Count-1 do
          begin
            LocalDirs[NumLocalDirs]:=DirList.GetItemPath(a);
            CreateDir[NumLocalDirs]:=true;
            Inc(NumLocalDirs);
            If NumLocalDirs=2001 then NumLocalDirs:=2000;
          end;
    end;
  end;
  Application.ProcessMessages;
end;


Procedure DoScanLocalFiles;
var a:integer;
    changed:boolean;
begin
  AddToLog ('Scan Local Directory Structure:',false);
  AddToLog ('===============================',false);
  AddToLog ('',false);
  AddToLog ('{See LocFiles.Lst for details}',true);
  LocalDirs:=TStringList.Create;
  LongDirs:=TStringList.Create;
  FirstFileInLocDir:=TStringList.Create;
  LastFileInLocDir:=TStringList.Create;
  For a:=0 to 2000 do begin
    LocalDirs.Add('');
    LongDirs.Add('');
    FirstFileInLocDir.Add('0');
    LastFileInLocDir.Add('0');
  end;
  LocalFiles:=TList.Create;
  NumLocalFiles:=0;
  NumLocalDirs:=0;
  LocalDirs[0]:=ProfileToDo.LocalRoot;
  CreateDir[0]:=true;
  NumLocalDirs:=1;
  with FrmProgress do
  begin
    LblSLF.Font.Color:=clWhite;
    LblSLFProg.Font.Color:=clWhite;
    LblSLF.Refresh;
    LblSLFProg.Refresh;
{    AddLocalDir(ProfileToDo.LocalRoot);}
    repeat begin
      changed:=false;
      for a:=0 to NumLocalDirs-1 do begin
        if CreateDir[a] then begin
          FirstFileInLocDir[a]:=IntToStr(NumLocalFiles);
          AddLocalDir(a);
          changed:=true;
          CreateDir[a]:=false;
          LastFileInLocDir[a]:=IntToStr(NumLocalFiles-1);
        end;
      end;
    end until changed=false;
    DirList.Directory:=GetMyPath;
    LblSLF.Font.Color:=clWindowText;
    LblSLFProg.Font.Color:=clWindowText;
    LblSLF.Refresh;
    LblSLFProg.Refresh;
  end;
  AddToLog ('{'+
             IntToStr(NumLocalFiles)
           + ' files ('
           + IntToStr(Round(TotalLocalSize/1024))
           + 'Kb) found in '
           + IntToStr(NumLocalDirs)
           + ' directories (inc root)'
           + '}' ,true);
  AddToLocLog ('{'+
             IntToStr(NumLocalFiles)
           + ' files ('
           + IntToStr(Round(TotalLocalSize/1024))
           + 'Kb) found in '
           + IntToStr(NumLocalDirs)
           + ' directories (inc root)'
           + '}' ,true);
end;


Procedure DoTransfer (ToDo:TProfile);
var a:integer;
    ret:boolean;
    LogFn:string;
    pLogFn:pchar;
begin
  Errors:=false;
  DeleteFile('ftpp21.log');
  DeleteFile('ftpdir.tmp');
  DeleteFile('session.log');
  DeleteFile('errors.log');
  DeleteFile('locfiles.lst');
  DeleteFile('remfiles.lst');
{  LogFn:=GetMyPath+'session.log'+#0;
  pLogFn:=@LogFn[1];
  FLogText:=_lcreat(pLogFn,0);
  LogFn:=GetMyPath+'errors.log'+#0;
  pLogFn:=@LogFn[1];
  FErrLogText:=_lcreat(pLogFn,0);}
  LogText:=TStringList.Create;
  ErrLogText:=TStringList.Create;
  LocLogText:=TStringList.Create;
  RemLogText:=TStringList.Create;
  ActLogText:=TStringList.Create;
  ProfileToDo:=ToDo;
  DoScanLocalFiles;
  if DoConnect then begin
    if DoLogin then begin
      if DoScanRemoteFiles then begin
        DoDecideActions;
        ret:=DoDeleteFiles;
        ret:=DoRemoveDirectories;
        ret:=DoMakeDirectories;
        ret:=DoCopyFiles
      end;
    end;
  end;
  DoDisconnect;
  CanGoByeBye:=true;
  if (RunningAuto and (not Errors)) then FrmProgress.Hide;
end;


end.
