unit Profiles;

interface

uses Classes, SysUtils, Dialogs, IniFiles,
     Code, Files;

type TProfile=record
     Name :string[30];
     Host, User, Pass :string[80];
     LocalRoot :string;
     LongRoot :string;
     RemoteRoot :string;
{     User, Pass :string[20];
     LocalRoot :string[64];
     LongRoot :string[192];
     RemoteRoot :string[192];}
     SubDirs, AllFiles, Delete, DelFromRoot, Rename, Upper :boolean;
     TimeDif :integer;
{     LastRun :TDateTime;
     HasRun :boolean;}
     UseLongFN :boolean;
     AllLogs :boolean;
     PauseFor :Integer;
     PauseAfter :Integer;
     end;

procedure AddProfile (NewProfile :TProfile);
function GetProfile (ProfileName :string) :TProfile;
function NumberOfProfiles :Integer;
function GetProfileNum (ProfileNum :integer) :TProfile;
procedure SetProfile (NewProfile :TProfile);
procedure LoadProfiles;
procedure SaveProfiles;
function IsProfile (ProfileName :string) :boolean;
procedure DeleteProfile (ProfileName :string);


implementation


var Profile :array [0..15] of TProfile;
    NumProfiles :integer;


function BoolToStr(b :boolean) :string;
  begin
    if b=false then Result:='0'
    else result:='1';
  end;
function StrToBool(s :string) :boolean;
  begin
    if s='1' then result:=true
    else result:=false;
  end;


procedure AddProfile (NewProfile :TProfile);
  begin
    Profile[NumProfiles]:=NewProfile;
    NumProfiles:=NumProfiles+1;
  end;


procedure DeleteProfile (ProfileName :string);
  var a, found: integer;
  begin
    found:=-1;
    for a:=0 to 15 do if Profile[a].Name=ProfileName then found:=a;
    if found<>-1 then begin
      for a:=found to 14 do Profile[a]:=Profile[a+1];
      dec(NumProfiles);
    end;
  end;


function GetProfile (ProfileName :string) :TProfile;
  var a, found :integer;
  begin
    found:=-1;
    for a:=0 to 15 do if Profile[a].Name=ProfileName then found:=a;
    if found<>-1 then result:=Profile[found];
  end;


function NumberOfProfiles :Integer;
  Begin
    Result:=NumProfiles;
  End;


function GetProfileNum (ProfileNum :integer) :TProfile;
  begin
    result:=Profile[ProfileNum];
  end;


procedure SetProfile (NewProfile :TProfile);
  var a, found :integer;
  begin
    found:=-1;
    for a:=0 to 15 do if Profile[a].Name=NewProfile.Name then found:=a;
    if found<>-1 then Profile[found]:=NewProfile;
  end;


{procedure LoadProfiles;
  var TempList: TStringlist;
      dummy :integer;
      a, p :integer;
      vs :string;
      v :real;
  begin
    TempList:=TStringList.Create;
    try
      dummy:=0;
      TempList.LoadFromFile('profiles.dat');
      v:=StrToFloat(TempList.Strings[0]);
      vs:=TempList.Strings[0];
      NumProfiles:=StrToInt(TempList.Strings[1]);
      p:=2;
      for a:=0 to NumProfiles-1 do
        begin
          Profile[a].Name:=TempList.Strings[p];
          p:=p+1;
          Profile[a].Host:=TempList.Strings[p];
          p:=p+1;
          Profile[a].User:=TempList.Strings[p];
          p:=p+1;
          Profile[a].Pass:=DJSDecode(TempList.Strings[p]);
          p:=p+1;
          Profile[a].LocalRoot:=TempList.Strings[p];
          p:=p+1;
          Profile[a].SubDirs:=StrToBool(TempList.Strings[p]);
          p:=p+1;
          Profile[a].AllFiles:=StrToBool(TempList.Strings[p]);
          p:=p+1;
          Profile[a].Delete:=StrToBool(TempList.Strings[p]);
          p:=p+1;
          Profile[a].DelFromRoot:=StrToBool(TempList.Strings[p]);
          p:=p+1;
          Profile[a].Rename:=StrToBool(TempList.Strings[p]);
          p:=p+1;
          if (vs='1.1') or (vs='1.2') then begin
            Profile[a].TimeDif:=StrToInt(TempList.Strings[p]);
            p:=p+1;
            if vs='1.2' then begin
              Profile[a].Upper:=StrToBool(TempList.Strings[p]);
              p:=p+1;
            end;
          end;
        end;
      dummy:=1;
      TempList.Free;
    except
      on EFOpenError do
        begin
          NumProfiles:=0;
          TempList.Free;
        end;
    end;
  end;}


procedure LoadProfiles;
var INI :TIniFile;
    a :Integer;
    v :Integer;
    ts: string;
begin
  INI:=TIniFile.Create(GetMyPath+'WhlSt.ini');
  v:=INI.ReadInteger('Main','Version',0);
  NumProfiles:=INI.ReadInteger('Main','NumProfiles',0);
  for a:=0 to NumProfiles-1 do
    begin
      Profile[a].Name:=INI.ReadString('Profile'+IntToStr(a),'Name','Error reading .ini file');
      Profile[a].Host:=INI.ReadString('Profile'+IntToStr(a),'Host','');
      Profile[a].User:=INI.ReadString('Profile'+IntToStr(a),'User','');
      Profile[a].Pass:=DJSDecode(INI.ReadString('Profile'+IntToStr(a),'Pass',
      ''));
{      '87BD038E89FFF32A6464A01AB66B9EDD8D9B1FE495A9FD0B8CA33984FFD2F6DCCB'));}
      Profile[a].LocalRoot:=INI.ReadString('Profile'+IntToStr(a),'LocalRoot','');
      Profile[a].LongRoot:=INI.ReadString('Profile'+IntToStr(a),'LongRoot',Profile[a].LocalRoot);
      Profile[a].SubDirs:=INI.ReadBool('Profile'+IntToStr(a),'SubDirs',False);
      Profile[a].AllFiles:=INI.ReadBool('Profile'+IntToStr(a),'AllFiles',False);
      Profile[a].Delete:=INI.ReadBool('Profile'+IntToStr(a),'Delete',False);
      Profile[a].DelFromRoot:=INI.ReadBool('Profile'+IntToStr(a),'DelFromRoot',False);
      Profile[a].Rename:=INI.ReadBool('Profile'+IntToStr(a),'Rename',False);
      Profile[a].TimeDif:=INI.ReadInteger('Profile'+IntToStr(a),'TimeDif',0);
      Profile[a].Upper:=INI.ReadBool('Profile'+IntToStr(a),'Upper',False);
      Profile[a].RemoteRoot:=INI.ReadString('Profile'+IntToStr(a),'RemoteRoot','');
{      Profile[a].HasRun:=INI.ReadBool('Profile'+IntToStr(a),'HasRun',False);
      ts:=INI.ReadString('Profile'+IntToStr(a),'LastRun','');}
      Profile[a].UseLongFN:=INI.ReadBool('Profile'+IntToStr(a),'UseLongFN',False);
      Profile[a].AllLogs:=INI.ReadBool('Profile'+IntToStr(a),'AllLogs',False);
{      try
        Profile[a].LastRun:=StrToDateTime(ts);
      except
        on EConvertError do Profile[a].HasRun:=false;
      end;}
      Profile[a].PauseFor:=INI.ReadInteger('Profile'+IntToStr(a),'PauseFor',10);
      Profile[a].PauseAfter:=INI.ReadInteger('Profile'+IntToStr(a),'PauseAfter',20);
    end;
end;


{procedure SaveProfiles;
  var TempList: TStringlist;
      dummy :integer;
      a :integer;
  begin
    TempList:=TStringList.Create;
    dummy:=TempList.Add(FloatToStr(1.2));
    dummy:=TempList.Add(IntToStr(NumProfiles));
    for a:=0 to NumProfiles-1 do
      begin
        dummy:=TempList.Add (Profile[a].Name);
        dummy:=TempList.Add (Profile[a].Host);
        dummy:=TempList.Add (Profile[a].User);
        dummy:=TempList.Add (DJSEncode(Profile[a].Pass));
        dummy:=TempList.Add (Profile[a].LocalRoot);
        dummy:=TempList.Add (BoolToStr(Profile[a].SubDirs));
        dummy:=TempList.Add (BoolToStr(Profile[a].AllFiles));
        dummy:=TempList.Add (BoolToStr(Profile[a].Delete));
        dummy:=TempList.Add (BoolToStr(Profile[a].DelFromRoot));
        dummy:=TempList.Add (BoolToStr(Profile[a].Rename));
        dummy:=TempList.Add (FloatToStr(Profile[a].TimeDif));
        dummy:=TempList.Add (BoolToStr(Profile[a].Upper));
      end;
    try
      dummy:=0;
      TempList.SaveToFile('profiles.dat');
      dummy:=1;
    finally
      if dummy<>1 then
        MessageDlg ('Error saving profiles to disk', mtError, [mbOK], 0);
      TempList.Free;
    end;
  end;}


procedure SaveProfiles;
var INI :TIniFile;
    a :integer;
begin
  if FileExists(GetMyPath+'WhlSt.ini') then DeleteFile (GetMyPath+'WhlSt.ini');
  INI:=TIniFile.Create(GetMyPath+'WhlSt.ini');
  INI.WriteInteger('Main','Version',141);
  INI.WriteInteger('Main','NumProfiles',NumProfiles);
  for a:=0 to NumProfiles-1 do
    begin
      INI.WriteString('Profile'+IntToStr(a),'Name',Profile[a].Name);
      INI.WriteString('Profile'+IntToStr(a),'Host',Profile[a].Host);
      INI.WriteString('Profile'+IntToStr(a),'User',Profile[a].User);
      INI.WriteString('Profile'+IntToStr(a),'Pass',DJSEncode(Profile[a].Pass));
      INI.WriteString('Profile'+IntToStr(a),'LocalRoot',Profile[a].LocalRoot);
      INI.WriteString('Profile'+IntToStr(a),'LongRoot',Profile[a].LongRoot);
      INI.WriteBool('Profile'+IntToStr(a),'SubDirs',Profile[a].SubDirs);
      INI.WriteBool('Profile'+IntToStr(a),'AllFiles',Profile[a].AllFiles);
      INI.WriteBool('Profile'+IntToStr(a),'Delete',Profile[a].Delete);
      INI.WriteBool('Profile'+IntToStr(a),'DelFromRoot',Profile[a].DelFromRoot);
      INI.WriteBool('Profile'+IntToStr(a),'Rename',Profile[a].Rename);
      INI.WriteInteger('Profile'+IntToStr(a),'TimeDif',Profile[a].TimeDif);
      INI.WriteBool('Profile'+IntToStr(a),'Upper',Profile[a].Upper);
      INI.WriteString('Profile'+IntToStr(a),'RemoteRoot',Profile[a].RemoteRoot);
{      INI.WriteBool('Profile'+IntToStr(a),'HasRun',Profile[a].HasRun);
      INI.WriteString('Profile'+IntToStr(a),'LastRun',DateTimeToStr(Profile[a].LastRun));}
      INI.WriteBool('Profile'+IntToStr(a),'UseLongFN',Profile[a].UseLongFN);
      INI.WriteBool('Profile'+IntToStr(a),'AllLogs',Profile[a].AllLogs);
      INI.WriteInteger('Profile'+IntToStr(a),'PauseFor',Profile[a].PauseFor);
      INI.WriteInteger('Profile'+IntToStr(a),'PauseAfter',Profile[a].PauseAfter);
    end;
end;


function IsProfile (ProfileName :string) :boolean;
  var a:integer;
      found:boolean;
  begin
    found:=false;
    for a:=0 to NumProfiles-1 do
      begin
        if AnsiLowerCase(Profile[a].Name)=
           AnsiLowerCase(ProfileName) then found:=true;
      end;
    Result:=found;
  end;


end.
