unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Spin, GConst, GPRog, Grids, Outline, DirOutln, FileCtrl,
  Buttons;

type
  TFrmMain = class(TForm)
    PnlPages: TPanel;
    Panel2: TPanel;
    NBMain: TNotebook;
    LblPageIntro: TLabel;
    LblPageConnection: TLabel;
    LblPageLocal: TLabel;
    LblPageRemote: TLabel;
    LblPageActions: TLabel;
    LblPageSpecial: TLabel;
    LblPageGo: TLabel;
    OptUpload: TRadioButton;
    OptDownload: TRadioButton;
    OptSync: TRadioButton;
    OptUploadAll: TRadioButton;
    OptUploadSince: TRadioButton;
    OptUploadUpdates: TRadioButton;
    OptCustom: TRadioButton;
    NBActions: TNotebook;
    LblActNoLoc: TLabel;
    LblActNoRem: TLabel;
    LblActNew: TLabel;
    LblActOld: TLabel;
    LstActNew: TComboBox;
    LstActOld: TComboBox;
    LstActNoRem: TComboBox;
    LstActNoLoc: TComboBox;
    LblTime: TLabel;
    TxtDate: TEdit;
    LblDate: TLabel;
    TxtTime: TEdit;
    PnlHelp: TPanel;
    PicHelp: TPaintBox;
    GroupBox1: TGroupBox;
    Label18: TLabel;
    SpnFTPPort: TSpinEdit;
    Label17: TLabel;
    SpnNumConnections: TSpinEdit;
    GroupBox2: TGroupBox;
    Label14: TLabel;
    TxtHost: TEdit;
    TxtUser: TEdit;
    TxtPass: TEdit;
    Label16: TLabel;
    Label15: TLabel;
    ChkUpdateTimes: TCheckBox;
    ChkAllowDeletes: TCheckBox;
    Label1: TLabel;
    TxtLocalRoot: TEdit;
    ComLocalBrowse: TBitBtn;
    Button1: TButton;
    procedure PicHelpPaint(Sender: TObject);
    procedure LblPageClick(Sender: TObject);
    procedure OptActionModeClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ComLocalBrowseClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TxtLocalRootChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

uses progress, SelDir;

{$R *.DFM}

procedure TFrmMain.PicHelpPaint(Sender: TObject);
begin
     with PicHelp.Canvas do begin
          Brush.Color:=clWhite;
          Brush.Style:=bsSolid;
          Pen.Color:=clWhite;
          Rectangle(0, 0, PicHelp.Width, PicHelp.Height);
          Brush.Style:=bsClear;
          Pen.Color:=clBlack;
          Rectangle(0, 0, PicHelp.Width, PicHelp.Height);
     end;
end;

procedure TFrmMain.LblPageClick(Sender: TObject);
begin
     LblPageIntro.Font.Color:=clWindowText;
     LblPageConnection.Font.Color:=clWindowText;
     LblPageLocal.Font.Color:=clWindowText;
     LblPageRemote.Font.Color:=clWindowText;
     LblPageActions.Font.Color:=clWindowText;
     LblPageSpecial.Font.Color:=clWindowText;
     LblPageGo.Font.Color:=clWindowText;
     TLabel(Sender).Font.Color:=clBlue;
     if Sender=LblPageIntro then begin
                NBMain.PageIndex:=0
     end else if Sender=LblPageConnection then begin
                 NBMain.PageIndex:=1
     end else if Sender=LblPageLocal then begin
                 NBMain.PageIndex:=2
     end else if Sender=LblPageRemote then begin
                 NBMain.PageIndex:=3
     end else if Sender=LblPageActions then begin
                 NBMain.PageIndex:=4
     end else if Sender=LblPageSpecial then begin
                 NBMain.PageIndex:=5
     end else if Sender=LblPageGo then begin
                 NBMain.PageIndex:=6;
     end;
end;

procedure TFrmMain.OptActionModeClick(Sender: TObject);
begin
     LblActNew.Enabled:=false;
     LblActOld.Enabled:=false;
     LblActNoLoc.Enabled:=false;
     LblActNoRem.Enabled:=false;
     LstActNew.Enabled:=false;
     LstActOld.Enabled:=false;
     LstActNoLoc.Enabled:=false;
     LstActNoRem.Enabled:=false;
     ChkAllowDeletes.Enabled:=false;
     ChkUpdateTimes.Enabled:=true;
     NBActions.PageIndex:=0;
     if OptCustom.Checked then begin
        LblActNew.Enabled:=true;
        LblActOld.Enabled:=true;
        LblActNoLoc.Enabled:=true;
        LblActNoRem.Enabled:=true;
        LstActNew.Enabled:=true;
        LstActOld.Enabled:=true;
        LstActNoLoc.Enabled:=true;
        LstActNoRem.Enabled:=true;
        ChkAllowDeletes.Enabled:=true;
     end else if OptUpload.Checked then begin
        ChkAllowDeletes.Enabled:=true;
        ChkAllowDeletes.Caption:='Allow WholeSite to delete files from the remote copy';
        LstActNew.ItemIndex:=alUpload;
        LstActOld.ItemIndex:=alNothing;
        LstActNoLoc.ItemIndex:=alNothing;
        if ChkAllowDeletes.Checked then LstActNoRem.ItemIndex:=alDelRem
                                   else LstActNoRem.ItemIndex:=alNothing;
     end else if OptDownload.Checked then begin
        ChkAllowDeletes.Enabled:=true;
        ChkAllowDeletes.Caption:='Allow WholeSite to delete files from the local copy';
        LstActOld.ItemIndex:=alDownload;
        LstActNew.ItemIndex:=alNothing;
        LstActNoRem.ItemIndex:=alNothing;
        if ChkAllowDeletes.Checked then LstActNoLoc.ItemIndex:=alDelRem
                                   else LstActNoLoc.ItemIndex:=alNothing;
        ChkUpdateTimes.Enabled:=false;
     end else if OptSync.Checked then begin
        LstActNew.ItemIndex:=alUpload;
        LstActOld.ItemIndex:=alDownload;
        LstActNoRem.ItemIndex:=alNothing;
        LstActNoLoc.ItemIndex:=alNothing;
        ChkUpdateTimes.Checked:=true;
        ChkUpdateTimes.Enabled:=false;
     end else if OptUploadAll.Checked then begin
        NBActions.PageIndex:=2;
     end else if OptUploadSince.Checked then begin
        NBActions.PageIndex:=1;
        LblDate.Enabled:=true;
        TxtDate.Enabled:=true;
        LblTime.Enabled:=true;
        TxtTime.Enabled:=true;
     end else if OptUploadUpdates.Checked then begin
        NBActions.PageIndex:=1;
        LblDate.Enabled:=false;
        TxtDate.Enabled:=false;
        LblTime.Enabled:=false;
        TxtTime.Enabled:=false;
     end;
end;

procedure TFrmMain.FormShow(Sender: TObject);
begin
     OptActionModeClick(Sender);
     TxtLocalRoot.Text:=FrmSelDir.Dirs.Directory;
end;

procedure TFrmMain.ComLocalBrowseClick(Sender: TObject);
begin
     if FrmSelDir.ShowModal=mrOK then
        TxtLocalRoot.Text:=FrmSelDir.Dirs.Directory;
end;

procedure TFrmMain.Button1Click(Sender: TObject);
begin           
     FrmMain.Hide;
     FrmProgress.ShowModal;
     FrmMain.Close;
end;

procedure TFrmMain.TxtLocalRootChange(Sender: TObject);
begin
     LocalRoot:=trim(TxtLocalRoot.Text);
     if copy(LocalRoot, Length(LocalRoot), 1)<>'\' then
        LocalRoot:=LocalRoot+'\';
end;

end.
