unit progress;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, DoIt, ExtCtrls, Ftpcli, GProg, ToDo, filedata, GConst;

type
  TFrmProgress = class(TForm)
    LstActive: TListView;
    BitBtn2: TBitBtn;
    TmrGo: TTimer;
    FtpClient1: TFtpClient;
    FtpClient2: TFtpClient;
    FtpClient3: TFtpClient;
    FtpClient4: TFtpClient;
    FtpClient5: TFtpClient;
    FtpClient6: TFtpClient;
    FtpClient7: TFtpClient;
    FtpClient8: TFtpClient;
    LstToDo: TListView;
    TxtLog: TMemo;
    procedure FormShow(Sender: TObject);
    procedure TmrGoTimer(Sender: TObject);
    procedure FtpClientRequestDone(Sender: TObject; RqType: TFtpRequest;
      Error: Word);
    procedure FtpClientCommand(Sender: TObject; var Cmd: string);
    procedure FtpClientDisplay(Sender: TObject; var Msg: string);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmProgress: TFrmProgress;
  pr: boolean = false;

implementation

{$R *.DFM}

procedure TFrmProgress.FormShow(Sender: TObject);
begin
     TmrGo.Enabled:=true;
end;

procedure TFrmProgress.TmrGoTimer(Sender: TObject);
var a: integer;
    Next: TDoThis;
    FileInfo: PTFileInfo;
    DirInfo: PTDirInfo;
begin
     if TmrGo.Interval=10 then begin
        TmrGo.Interval:=20;
        MainLoop;
     end else begin
        for a:=1 to 8 do begin
            if Commands[a].Count=0 then begin
               Next:=NextRemoteAction;
               if Next.Action=TDRemDirCreate then begin
                  DirInfo:=PTDirInfo(Next.Param);
                  Commands[a].Add('mkd');
                  Connection[a].HostFileName:=DirInfo.Name;
                  FtpClientRequestDone(Connection[a], ftpNone, 0);
               end else if Next.Action=TDUpload then begin
                   FileInfo:=PTFileInfo(Next.Param);
{                   messagedlg(FileInfo.Name, mtinformation, [mbok], 0);}
                   if FileInfo.Dir.Name<>LastDir[a] then begin
                      Commands[a].Add('cwd '+RemoteRoot);
                      Commands[a].Add('cwd '+FileInfo.Dir.Name);
                      LastDir[a]:=FileInfo.Dir.Name;
                   end;
                   Connection[a].LocalFileName:=ToWindoze(LocalRoot+FileInfo.Dir.Name+'/'+FileInfo.Name);
                   TxtLog.Lines.Add(Connection[a].LocalFileName);
                   Commands[a].Add('put '+FileInfo.Name);
                   FtpClientRequestDone(Connection[a], ftpNone, 0);
               end;
            end else begin
               if Retry[a].Needed then begin
                  if Retry[a].Ready then begin
                     if Retry[a].Time<Now then begin
                        Retry[a].Needed:=false;
                        if Connection[a].Connected then messagedlg(inttostr(a),mtinformation,[mbok],0);
                        Connection[a].Abort;
{                        FtpClientRequestDone(Connection[a], ftpNone, 0);}
                     end;
                  end;
               end;
            end;
        end;
     end;
     if CActive and (now-LRActive>RefreshDelay) then begin
        LstActive.Refresh;
        LRActive:=now;
        CActive:=false;
     end;
     if CToDo and (now-LRToDo>RefreshDelay) then begin
        LstToDo.Refresh;
        LRToDo:=now;
        CToDo:=false;
     end;
end;

procedure TFrmProgress.FtpClientRequestDone(Sender: TObject;
  RqType: TFtpRequest; Error: Word);
var Index: integer;
    WhatNext: integer;
    Next: TDoThis;
    Path, FileName: string;
    OK: boolean;
    a: integer;
begin
{     MessageDlg('test '+inttostr(TFTPClient(Sender).Tag), mtinformation, [mbok], 0);}
     index:=TFTPClient(Sender).Tag;
     if RqType=FtpOpenAsync then begin            { connection is open...}
        LstActive.Items[index].SubItems[0]:='Connected, sending username';
        CActive:=true;
        Connection[Index].UserAsync;
     end else if RqType=FtpUserAsync then begin   { username aknowlaged }
        LstActive.Items[index].SubItems[0]:='Connected, sending username and password';
        CActive:=true;
        Connection[Index].PassAsync;
     end else if RqType=FtpPassAsync then begin   { password aknowlaged }
        LstActive.Items[index].SubItems[0]:='Connected, finding root directory';
        CActive:=true;
        Connection[Index].PwdAsync;
     end else if RqType=FtpPwdAsync then begin   { pwd aknowlaged }
        RemoteRoot:=Connection[Index].DirResult;
        LstActive.Items[index].SubItems[0]:='Connected, telling server to expect binary data';
        CActive:=true;
        Connection[Index].TypeBinaryAsync;
     end else if RqType=FtpTypeSetAsync then begin   { pwd aknowlaged }
        LstActive.Items[index].SubItems[0]:='Connected, waiting for instructions';
        CActive:=true;
        Commands[Index].Clear;
     end else if RqType=FtpMkdAsync then begin
        Connection[Index].HostFileName:=#0;
        LstActive.Items[index].SubItems[0]:='Waiting for instructions';
        CActive:=true;
        Commands[Index].Delete(0);
        RegisterDone(TDRemDirCreate);
     end else if RqType=FtpCwdAsync then begin
        LstActive.Items[index].SubItems[0]:='Waiting for instructions';
        CActive:=true;
        Commands[Index].Delete(0);
     end else if RqType=FtpPutAsync then begin
        LstActive.Items[index].SubItems[0]:='Waiting for instructions';
        CActive:=true;
        RegisterDone(TDUpload);
        Commands[Index].Delete(0);
{        if error<>0 then messagedlg(inttostr(Error), mtinformation, [mbok], 0);}
     end;
     if Commands[Index].Count>0 then begin
{           messagedlg(Commands[Index].Strings[0], mtinformation, [mbok], 0);}
        if Commands[Index].Strings[0]='mkd' then begin
           LstActive.Items[index].SubItems[0]:='Creating directory: '+Connection[Index].HostFileName;
           CActive:=true;
           Connection[Index].MkdAsync;
        end else if copy(Commands[Index].Strings[0], 1, 3)='cwd' then begin
           Connection[Index].HostDirName:=copy(Commands[Index].Strings[0], 5, BIG_INT);
           LstActive.Items[index].SubItems[0]:='Moving to directory: '+Connection[Index].HostDirName;
{           messagedlg(Connection[Index].HostDirName, mtinformation, [mbok], 0);}
           CActive:=true;
           Connection[Index].CwdAsync;
        end else if copy(Commands[Index].Strings[0], 1, 3)='put' then begin
           Connection[Index].HostFileName:=copy(Commands[Index].Strings[0], 5, BIG_INT);
           LstActive.Items[index].SubItems[0]:='Uploading file: '+LastDir[Index]+'/'+Connection[Index].HostFileName;
{           messagedlg(LastDir[Index]+Connection[Index].HostFileName, mtinformation, [mbok], 0);}
           CActive:=true;
           Connection[Index].PutAsync;
        end;
     end;
     CActive:=true;
     UpdateToDo;
     Application.ProcessMessages;
end;

procedure TFrmProgress.FtpClientCommand(Sender: TObject; var Cmd: string);
var index: integer;
begin
{     MessageDlg(cmd+' '+inttostr(TFTPClient(Sender).Tag), mtinformation, [mbok], 0);}
     index:=TFTPClient(Sender).Tag;
end;

procedure TFrmProgress.FtpClientDisplay(Sender: TObject; var Msg: string);
begin
     TxtLog.Lines.Add(inttostr(TFtpClient(Sender).Tag)+': '+Msg);
     if Msg='! Error reading file' then begin
        Retry[TFtpClient(Sender).Tag].Needed:=true;
        Retry[TFtpClient(Sender).Tag].Ready:=false;
     end;
     if pos('226', Msg)>0 then begin
        Retry[TFtpClient(Sender).Tag].Ready:=true;
        Retry[TFtpClient(Sender).Tag].time:=now+EncodeTime(0, 0, 0, 200);
     end;
end;

end.
